/* getline.c --- Implementation of replacement getline function.
   Copyright (C) 2005 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2, or (at
   your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA.  */
#include <sys/cdefs.h>
__RCSID("$NetBSD: getline.c,v 1.1.1.1.26.1 2017/05/13 06:23:23 snj Exp $");


/* Written by Simon Josefsson. */

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include "getdelim.h"
#include "getline.h"

ssize_t
getline (char **lineptr, size_t *n, FILE *stream)
{
  return getdelim (lineptr, n, '\n', stream);
}
